From 5c360cbab832216187f77dc43880b1264d5ae63c Mon Sep 17 00:00:00 2001
From: David Malcolm <dmalcolm@redhat.com>
Date: Thu, 29 Mar 2018 12:28:55 -0400
Subject: [PATCH 10/49] {NEEDS B&R} C++: improvements to diagnostics using %P
 (more PR c++/85110)

This patch is based on grepping the C++ frontend for %P and %qP
i.e. diagnostics that refer to a parameter number.  It fixes up
these diagnostics to highlight the pertinent param where appropriate
(and possible), along with various other tweaks, as described in the
ChangeLog.

gcc/cp/ChangeLog:
	PR c++/85110
	* call.c (conversion_null_warnings): Try to use the location of
	the expression for the warnings.  Add notes showing the parameter
	of the function decl, where available.
	(get_fndecl_argument_location): Gracefully reject
	non-FUNCTION_DECLs.
	(maybe_inform_about_fndecl_for_bogus_argument_init): New function.
	(convert_like_real): Use it in various places to avoid repetition.
	* cp-tree.h (maybe_inform_about_fndecl_for_bogus_argument_init):
	New declaration.
	* decl2.c: Include "gcc-rich-location.h".
	(check_default_args): Use the location of the parameter when
	complaining about parameters with missing default arguments in
	preference to that of the fndecl.
	Attempt to record the location of first parameter with a default
	argument and add it as a secondary range to such errors.
	* typeck.c (convert_arguments): When complaining about parameters
	with incomplete types, attempt to use the location of the
	argument.  Where available, add a note showing the pertinent
	parameter in the fndecl.
	(convert_for_assignment): When complaining about bad conversions
	at function calls, use the location of the unstripped argument.
	Update the note about the callee to use the location of the
	pertinent parameter, and to use
	maybe_inform_about_fndecl_for_bogus_argument_init.
	(convert_for_initialization): When checking for bogus references,
	add an auto_diagnostic_group, and update the note to use the
	location of the pertinent parameter, rather than just the callee.

gcc/testsuite/ChangeLog:
	PR c++/85110
	* g++.dg/diagnostic/missing-default-args.C: New test.
	* g++.dg/diagnostic/param-type-mismatch-3.C: New test.
	* g++.dg/diagnostic/param-type-mismatch.C: Add tests for invalid
	references and incomplete types.
	* g++.dg/warn/Wconversion-null-4.C: New test.
---
 gcc/cp/call.c                                      | 79 ++++++++++++++--------
 gcc/cp/cp-tree.h                                   |  1 +
 gcc/cp/decl2.c                                     | 16 ++++-
 gcc/cp/typeck.c                                    | 30 +++++---
 .../g++.dg/diagnostic/missing-default-args.C       | 53 +++++++++++++++
 .../g++.dg/diagnostic/param-type-mismatch-3.C      | 26 +++++++
 .../g++.dg/diagnostic/param-type-mismatch.C        | 41 +++++++++++
 gcc/testsuite/g++.dg/warn/Wconversion-null-4.C     | 37 ++++++++++
 8 files changed, 241 insertions(+), 42 deletions(-)
 create mode 100644 gcc/testsuite/g++.dg/diagnostic/missing-default-args.C
 create mode 100644 gcc/testsuite/g++.dg/diagnostic/param-type-mismatch-3.C
 create mode 100644 gcc/testsuite/g++.dg/warn/Wconversion-null-4.C

diff --git a/gcc/cp/call.c b/gcc/cp/call.c
index 3bc42f5..b1709cb 100644
--- a/gcc/cp/call.c
+++ b/gcc/cp/call.c
@@ -6609,16 +6609,24 @@ conversion_null_warnings (tree totype, tree expr, tree fn, int argnum)
   if (null_node_p (expr) && TREE_CODE (totype) != BOOLEAN_TYPE
       && ARITHMETIC_TYPE_P (totype))
     {
-      source_location loc =
-	expansion_point_location_if_in_system_header (input_location);
-
       if (fn)
-	warning_at (loc, OPT_Wconversion_null,
-		    "passing NULL to non-pointer argument %P of %qD",
-		    argnum, fn);
+	{
+	  source_location loc = EXPR_LOC_OR_LOC (expr, input_location);
+	  loc = expansion_point_location_if_in_system_header (loc);
+	  auto_diagnostic_group d;
+	  if (warning_at (loc, OPT_Wconversion_null,
+			  "passing NULL to non-pointer argument %P of %qD",
+			  argnum, fn))
+	    inform (get_fndecl_argument_location (fn, argnum),
+		    "  declared here");
+	}
       else
-	warning_at (loc, OPT_Wconversion_null,
-		    "converting to non-pointer type %qT from NULL", totype);
+	{
+	  source_location loc
+	    = expansion_point_location_if_in_system_header (input_location);
+	  warning_at (loc, OPT_Wconversion_null,
+		      "converting to non-pointer type %qT from NULL", totype);
+	}
     }
 
   /* Issue warnings if "false" is converted to a NULL pointer */
@@ -6626,9 +6634,15 @@ conversion_null_warnings (tree totype, tree expr, tree fn, int argnum)
 	   && TYPE_PTR_P (totype))
     {
       if (fn)
-	warning_at (input_location, OPT_Wconversion_null,
-		    "converting %<false%> to pointer type for argument %P "
-		    "of %qD", argnum, fn);
+	{
+	  source_location loc = EXPR_LOC_OR_LOC (expr, input_location);
+	  auto_diagnostic_group d;
+	  if (warning_at (loc, OPT_Wconversion_null,
+			  "converting %<false%> to pointer type for argument "
+			  "%P of %qD", argnum, fn))
+	    inform (get_fndecl_argument_location (fn, argnum),
+		    "  declared here");
+	}
       else
 	warning_at (input_location, OPT_Wconversion_null,
 		    "converting %<false%> to pointer type %qT", totype);
@@ -6668,6 +6682,10 @@ maybe_print_user_conv_context (conversion *convs)
 location_t
 get_fndecl_argument_location (tree fndecl, int argnum)
 {
+  /* Gracefully fail for e.g. TEMPLATE_DECL.  */
+  if (TREE_CODE (fndecl) != FUNCTION_DECL)
+    return DECL_SOURCE_LOCATION (fndecl);
+
   int i;
   tree param;
 
@@ -6685,6 +6703,18 @@ get_fndecl_argument_location (tree fndecl, int argnum)
   return DECL_SOURCE_LOCATION (param);
 }
 
+/* If FNDECL is non-NULL, issue a note highlighting ARGNUM
+   within its declaration (or the fndecl itself if something went
+   wrong).  */
+
+void
+maybe_inform_about_fndecl_for_bogus_argument_init (tree fn, int argnum)
+{
+  if (fn)
+    inform (get_fndecl_argument_location (fn, argnum),
+	    "  initializing argument %P of %qD", argnum, fn);
+}
+
 /* Perform the conversions in CONVS on the expression EXPR.  FN and
    ARGNUM are used for diagnostics.  ARGNUM is zero based, -1
    indicates the `this' argument of a method.  INNER is nonzero when
@@ -6762,9 +6792,8 @@ convert_like_real (conversion *convs, tree expr, tree fn, int argnum,
 					     complain);
 	      else
 		expr = cp_convert (totype, expr, complain);
-	      if (complained && fn)
-		inform (DECL_SOURCE_LOCATION (fn),
-			"  initializing argument %P of %qD", argnum, fn);
+	      if (complained)
+		maybe_inform_about_fndecl_for_bogus_argument_init (fn, argnum);
 	      return expr;
 	    }
 	  else if (t->kind == ck_user || !t->bad_p)
@@ -6791,9 +6820,8 @@ convert_like_real (conversion *convs, tree expr, tree fn, int argnum,
 				  "invalid conversion from %qH to %qI",
 				  TREE_TYPE (expr), totype);
 	}
-      if (complained && fn)
-	inform (get_fndecl_argument_location (fn, argnum),
-		"  initializing argument %P of %qD", argnum, fn);
+      if (complained)
+	maybe_inform_about_fndecl_for_bogus_argument_init (fn, argnum);
 
       return cp_convert (totype, expr, complain);
     }
@@ -6915,9 +6943,7 @@ convert_like_real (conversion *convs, tree expr, tree fn, int argnum,
 		       ? LOOKUP_IMPLICIT : LOOKUP_NORMAL);
 	  build_user_type_conversion (totype, convs->u.expr, flags, complain);
 	  gcc_assert (seen_error ());
-	  if (fn)
-	    inform (DECL_SOURCE_LOCATION (fn),
-		    "  initializing argument %P of %qD", argnum, fn);
+	  maybe_inform_about_fndecl_for_bogus_argument_init (fn, argnum);
 	}
       return error_mark_node;
 
@@ -7011,9 +7037,7 @@ convert_like_real (conversion *convs, tree expr, tree fn, int argnum,
 	    {
 	      auto_diagnostic_group d;
 	      maybe_print_user_conv_context (convs);
-	      if (fn)
-		inform (DECL_SOURCE_LOCATION (fn),
-			"  initializing argument %P of %qD", argnum, fn);
+	      maybe_inform_about_fndecl_for_bogus_argument_init (fn, argnum);
 	    }
 	  return error_mark_node;
 	}
@@ -7064,9 +7088,7 @@ convert_like_real (conversion *convs, tree expr, tree fn, int argnum,
 	{
 	  auto_diagnostic_group d;
 	  maybe_print_user_conv_context (convs);
-	  if (fn)
-	    inform (DECL_SOURCE_LOCATION (fn),
-		    "  initializing argument %P of %qD", argnum, fn);
+	  maybe_inform_about_fndecl_for_bogus_argument_init (fn, argnum);
 	}
 
       return build_cplus_new (totype, expr, complain);
@@ -7093,9 +7115,8 @@ convert_like_real (conversion *convs, tree expr, tree fn, int argnum,
 	    else
 	      gcc_unreachable ();
 	    maybe_print_user_conv_context (convs);
-	    if (fn)
-	      inform (DECL_SOURCE_LOCATION (fn),
-		      "  initializing argument %P of %qD", argnum, fn);
+	    maybe_inform_about_fndecl_for_bogus_argument_init (fn, argnum);
+
 	    return error_mark_node;
 	  }
 
diff --git a/gcc/cp/cp-tree.h b/gcc/cp/cp-tree.h
index 055f2bc..0ac4175 100644
--- a/gcc/cp/cp-tree.h
+++ b/gcc/cp/cp-tree.h
@@ -6087,6 +6087,7 @@ extern bool can_convert_arg_bad			(tree, tree, tree, int,
 extern int conv_flags				(int, int, tree, tree, int);
 extern struct conversion * good_conversion	(tree, tree, tree, int, tsubst_flags_t);
 extern location_t get_fndecl_argument_location  (tree, int);
+extern void maybe_inform_about_fndecl_for_bogus_argument_init (tree, int);
 
 
 /* A class for recording information about access failures (e.g. private
diff --git a/gcc/cp/decl2.c b/gcc/cp/decl2.c
index a5ad0ee..64a1db3 100644
--- a/gcc/cp/decl2.c
+++ b/gcc/cp/decl2.c
@@ -48,6 +48,7 @@ along with GCC; see the file COPYING3.  If not see
 #include "intl.h"
 #include "c-family/c-ada-spec.h"
 #include "asan.h"
+#include "gcc-rich-location.h"
 
 /* Id for dumping the raw trees.  */
 int raw_dump_id;
@@ -5117,14 +5118,25 @@ check_default_args (tree x)
 {
   tree arg = TYPE_ARG_TYPES (TREE_TYPE (x));
   bool saw_def = false;
+  location_t loc_of_first_default_arg = UNKNOWN_LOCATION;
   int i = 0 - (TREE_CODE (TREE_TYPE (x)) == METHOD_TYPE);
   for (; arg && arg != void_list_node; arg = TREE_CHAIN (arg), ++i)
     {
       if (TREE_PURPOSE (arg))
-	saw_def = true;
+	{
+	  saw_def = true;
+	  location_t loc = get_fndecl_argument_location (x, i);
+	  if (loc != DECL_SOURCE_LOCATION (x))
+	    loc_of_first_default_arg = loc;
+	}
       else if (saw_def && !PACK_EXPANSION_P (TREE_VALUE (arg)))
 	{
-	  error ("default argument missing for parameter %P of %q+#D", i, x);
+	  location_t loc = get_fndecl_argument_location (x, i);
+	  gcc_rich_location richloc (loc);
+	  if (loc_of_first_default_arg != UNKNOWN_LOCATION)
+	    richloc.add_range (loc_of_first_default_arg, false);
+	  error_at (&richloc,
+		    "default argument missing for parameter %P of %q#D", i, x);
 	  TREE_PURPOSE (arg) = error_mark_node;
 	}
     }
diff --git a/gcc/cp/typeck.c b/gcc/cp/typeck.c
index 122d9dc..7eb5a0e 100644
--- a/gcc/cp/typeck.c
+++ b/gcc/cp/typeck.c
@@ -3924,11 +3924,19 @@ convert_arguments (tree typelist, vec<tree, va_gc> **values, tree fndecl,
 	    {
               if (complain & tf_error)
                 {
+		  location_t loc = EXPR_LOC_OR_LOC (val, input_location);
                   if (fndecl)
-                    error ("parameter %P of %qD has incomplete type %qT",
-                           i, fndecl, type);
+		    {
+		      auto_diagnostic_group d;
+		      error_at (loc,
+				"parameter %P of %qD has incomplete type %qT",
+				i, fndecl, type);
+		      inform (get_fndecl_argument_location (fndecl, i),
+			      "  declared here");
+		    }
                   else
-                    error ("parameter %P has incomplete type %qT", i, type);
+		    error_at (loc, "parameter %P has incomplete type %qT", i,
+			      type);
                 }
 	      parmval = error_mark_node;
 	    }
@@ -8710,6 +8718,7 @@ convert_for_assignment (tree type, tree rhs,
 {
   tree rhstype;
   enum tree_code coder;
+  location_t rhs_loc = EXPR_LOC_OR_LOC (rhs, input_location);
 
   /* Strip NON_LVALUE_EXPRs since we aren't using as an lvalue.  */
   if (TREE_CODE (rhs) == NON_LVALUE_EXPR)
@@ -8819,20 +8828,19 @@ convert_for_assignment (tree type, tree rhs,
 	      else if (fndecl)
 		{
 		  auto_diagnostic_group d;
-		  location_t loc = cp_expr_location (rhs);
 		  range_label_for_type_mismatch rhs_label (rhstype, type);
 		  range_label *label = &rhs_label;
-		  if (loc == UNKNOWN_LOCATION)
+		  if (rhs_loc == UNKNOWN_LOCATION)
 		    {
-		      loc = input_location;
+		      rhs_loc = input_location;
 		      label = NULL;
 		    }
-		  gcc_rich_location richloc (loc, label);
+		  gcc_rich_location richloc (rhs_loc, label);
 		  error_at (&richloc,
 			    "cannot convert %qH to %qI",
 			    rhstype, type);
-		  inform (get_fndecl_argument_location (fndecl, parmnum),
-			  "  initializing argument %P of %qD", parmnum, fndecl);
+		  maybe_inform_about_fndecl_for_bogus_argument_init (fndecl,
+								     parmnum);
 		}
 	      else
 		switch (errtype)
@@ -8998,6 +9006,7 @@ convert_for_initialization (tree exp, tree type, tree rhs, int flags,
 
   if (codel == REFERENCE_TYPE)
     {
+      auto_diagnostic_group d;
       /* This should eventually happen in convert_arguments.  */
       int savew = 0, savee = 0;
 
@@ -9007,9 +9016,8 @@ convert_for_initialization (tree exp, tree type, tree rhs, int flags,
 
       if (fndecl
 	  && (warningcount + werrorcount > savew || errorcount > savee))
-	inform (DECL_SOURCE_LOCATION (fndecl),
+	inform (get_fndecl_argument_location (fndecl, parmnum),
 		"in passing argument %P of %qD", parmnum, fndecl);
-
       return rhs;
     }
 
diff --git a/gcc/testsuite/g++.dg/diagnostic/missing-default-args.C b/gcc/testsuite/g++.dg/diagnostic/missing-default-args.C
new file mode 100644
index 0000000..f681842
--- /dev/null
+++ b/gcc/testsuite/g++.dg/diagnostic/missing-default-args.C
@@ -0,0 +1,53 @@
+// { dg-options "-fdiagnostics-show-caret" }
+
+/* Function.  */
+
+void test_1 (int a, int b = 42, int c, int d); // { dg-line test_1 }
+
+// { dg-error "default argument missing for parameter 3 of " "" { target *-*-* } test_1 }
+/* { dg-begin-multiline-output "" }
+ void test_1 (int a, int b = 42, int c, int d);
+                     ~~~~~~~~~~  ~~~~^
+   { dg-end-multiline-output "" } */
+
+// { dg-error "default argument missing for parameter 4 of " "" { target *-*-* } test_1 }
+/* { dg-begin-multiline-output "" }
+ void test_1 (int a, int b = 42, int c, int d);
+                     ~~~~~~~~~~         ~~~~^
+   { dg-end-multiline-output "" } */
+
+
+/* Non-static member fn.  */
+
+struct test_2
+{
+  void member_2 (int a, int b = 42, int c); // { dg-error "default argument missing for parameter 3 of " }
+};
+
+
+/* { dg-begin-multiline-output "" }
+   void member_2 (int a, int b = 42, int c);
+                         ~~~~~~~~~~  ~~~~^
+   { dg-end-multiline-output "" } */
+
+
+/* Static member fn.  */
+
+struct test_3
+{
+  static void member_3 (int a, int b = 42, int c); // { dg-error "default argument missing for parameter 3 of " }
+};
+/* { dg-begin-multiline-output "" }
+   static void member_3 (int a, int b = 42, int c);
+                                ~~~~~~~~~~  ~~~~^
+   { dg-end-multiline-output "" } */
+
+
+/* Template.  */
+
+template <typename Type>
+void test_4 (int a, int b = 42, int c); // { dg-error "default argument missing for parameter 3 of " }
+/* { dg-begin-multiline-output "" }
+ void test_4 (int a, int b = 42, int c);
+                     ~~~~~~~~~~  ~~~~^
+   { dg-end-multiline-output "" } */
diff --git a/gcc/testsuite/g++.dg/diagnostic/param-type-mismatch-3.C b/gcc/testsuite/g++.dg/diagnostic/param-type-mismatch-3.C
new file mode 100644
index 0000000..0534e6a
--- /dev/null
+++ b/gcc/testsuite/g++.dg/diagnostic/param-type-mismatch-3.C
@@ -0,0 +1,26 @@
+// { dg-do compile { target c++14 } }
+// { dg-options "-fdiagnostics-show-caret" }
+
+void f2(int, char (*)(int), int) { } // { dg-line f2 }
+
+void test_1 ()
+{
+  auto glambda = [](auto a) { return a; }; // { dg-line candidate }
+  int (*fp)(int) = glambda;
+  f2(1, glambda, 3); // { dg-error "invalid user-defined conversion" }
+  /* { dg-begin-multiline-output "" }
+   f2(1, glambda, 3);
+         ^~~~~~~
+     { dg-end-multiline-output "" } */
+  // { dg-message "candidate is: " "" { target *-*-* } candidate }
+  /* { dg-begin-multiline-output "" }
+   auto glambda = [](auto a) { return a; };
+                           ^
+     { dg-end-multiline-output "" } */
+  // { dg-message "no known conversion from " "" { target *-*-* } candidate }
+  // { dg-message "initializing argument 2 of " "" { target *-*-* } f2 }
+  /* { dg-begin-multiline-output "" }
+ void f2(int, char (*)(int), int) { }
+              ^~~~~~~~~~~~~
+     { dg-end-multiline-output "" } */
+}
diff --git a/gcc/testsuite/g++.dg/diagnostic/param-type-mismatch.C b/gcc/testsuite/g++.dg/diagnostic/param-type-mismatch.C
index 50bbd4a..ac101b6 100644
--- a/gcc/testsuite/g++.dg/diagnostic/param-type-mismatch.C
+++ b/gcc/testsuite/g++.dg/diagnostic/param-type-mismatch.C
@@ -226,4 +226,45 @@ int test_11 (int first, int second, float third)
      { dg-end-multiline-output "" } */
 }
 
+/* Bad reference.  */
+
+struct s12;
+
+extern int callee_12 (int one, s12 &second, float three); // { dg-line callee_12 }
+
+int test_12 (int first, int second, float third)
+{
+  return callee_12 (first, second, third); // { dg-error "invalid initialization of reference of " }
+  /* { dg-begin-multiline-output "" }
+   return callee_12 (first, second, third);
+                            ^~~~~~
+     { dg-end-multiline-output "" } */
+  // { dg-message "in passing argument 2 of " "" { target *-*-* } callee_12 }
+  /* { dg-begin-multiline-output "" }
+ extern int callee_12 (int one, s12 &second, float three);
+                                ~~~~~^~~~~~
+     { dg-end-multiline-output "" } */
+}
+
+/* Incomplete type.  */
+
+struct s13;
+
+extern int callee_13 (int one, s13 second, float three); // { dg-line callee_13 }
+
+int test_13 (int first, int second, float third)
+{
+  return callee_13 (first, second, third); // { dg-error "has incomplete type" }
+  /* { dg-begin-multiline-output "" }
+   return callee_13 (first, second, third);
+                            ^~~~~~
+     { dg-end-multiline-output "" } */
+  // { dg-message "declared here" "" { target *-*-* } callee_13 }
+  /* { dg-begin-multiline-output "" }
+ extern int callee_13 (int one, s13 second, float three);
+                                ~~~~^~~~~~
+     { dg-end-multiline-output "" } */
+}
+
+
 // TODO: template callsite
diff --git a/gcc/testsuite/g++.dg/warn/Wconversion-null-4.C b/gcc/testsuite/g++.dg/warn/Wconversion-null-4.C
new file mode 100644
index 0000000..5de21e6
--- /dev/null
+++ b/gcc/testsuite/g++.dg/warn/Wconversion-null-4.C
@@ -0,0 +1,37 @@
+// { dg-do compile  }
+// { dg-options "-Wconversion-null -fdiagnostics-show-caret" }
+
+#include <stddef.h>
+
+void callee_1 (int, int, int) {} // { dg-message "declared here" }
+
+void caller_1 (void)
+{
+  callee_1 (0, NULL, 2); // { dg-warning "passing NULL to non-pointer argument 2 of" }
+  /* { dg-begin-multiline-output "" }
+   callee_1 (0, NULL, 2);
+                ^~~~
+     { dg-end-multiline-output "" } */
+  /* { dg-begin-multiline-output "" }
+ void callee_1 (int, int, int) {}
+                     ^~~
+     { dg-end-multiline-output "" } */
+}
+
+void callee_2 (int, void *, int) {} // { dg-message "declared here" "" { target { ! c++11 } } }
+// { dg-message "initializing argument 2 of " "" { target c++11 } .-1 }
+
+void caller_2 (void)
+{
+  callee_2 (0, false, 2); // { dg-warning "converting 'false' to pointer type for argument 2 of " "" { target { ! c++11 } } }
+  // { dg-error "cannot convert" "" { target c++11 } .-1 }
+
+  /* { dg-begin-multiline-output "" }
+   callee_2 (0, false, 2);
+                ^~~~~
+     { dg-end-multiline-output "" } */
+  /* { dg-begin-multiline-output "" }
+ void callee_2 (int, void *, int) {}
+                     ^~~~~~
+     { dg-end-multiline-output "" } */
+}
-- 
1.8.5.3